unit URichEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ShellAPI,ComCtrls, Buttons, ImgList, Spin, ToolWin,
  Menus;

type
  TMainform = class(TForm)
    RichEdit1: TRichEdit;
    ToolBar1: TToolBar;
    BtnLimpar: TToolButton;
    ToolButton4: TToolButton;
    BtnImprimir: TToolButton;
    ToolButton18: TToolButton;
    BtnRecortar: TToolButton;
    BtnCopiar: TToolButton;
    BtnColar: TToolButton;
    ToolButton7: TToolButton;
    BtnNegrito: TToolButton;
    BtnItalico: TToolButton;
    BtnSublinhado: TToolButton;
    BtnEsquerda: TToolButton;
    ToolButton19: TToolButton;
    BtnCentralizado: TToolButton;
    BtnDireita: TToolButton;
    BtnMarcador: TToolButton;
    ToolButton1: TToolButton;
    ToolBar2: TToolBar;
    ToolButton2: TToolButton;
    ComboBox1: TComboBox;
    ToolButton3: TToolButton;
    Spin1: TSpinEdit;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ImagesBR: TImageList;
    BtnTachado: TToolButton;
    BtnSalvar: TToolButton;
    PrintDialog1: TPrintDialog;
    BtnRecuo: TToolButton;
    StatusBar1: TStatusBar;
    ToolButton8: TToolButton;
    BtnAumentarFonte: TToolButton;
    BtnDiminuirFonte: TToolButton;
    SaveDialog1: TSaveDialog;
    BtnAbrir: TToolButton;
    ToolButton9: TToolButton;
    OpenDialog1: TOpenDialog;
    BtnCor: TToolButton;
    ToolButton11: TToolButton;
    ColorDialog1: TColorDialog;
    BtnSair: TToolButton;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    menuAbrir: TMenuItem;
    menuSalvar: TMenuItem;
    N1: TMenuItem;
    menuImprimir: TMenuItem;
    N2: TMenuItem;
    menuSair: TMenuItem;
    menuNovo: TMenuItem;
    Editar1: TMenuItem;
    menuRecortar: TMenuItem;
    menuCopiar: TMenuItem;
    menuColar: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure BtnSairClick(Sender: TObject);
    procedure BtnNegritoClick(Sender: TObject);
    procedure BtnItalicoClick(Sender: TObject);
    procedure BtnSublinhadoClick(Sender: TObject);
    procedure BtnEsquerdaClick(Sender: TObject);
    procedure BtnCentralizadoClick(Sender: TObject);
    procedure BtnDireitaClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Spin1Change(Sender: TObject);
    procedure RichEdit1SelectionChange(Sender: TObject);
    function CurrText : TTextAttributes;
    procedure BtnTachadoClick(Sender: TObject);
    procedure BtnImprimirClick(Sender: TObject);
    procedure BtnSalvarClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure BtnLimparClick(Sender: TObject);
    procedure BtnMarcadorClick(Sender: TObject);
    procedure BtnRecuoClick(Sender: TObject);
    procedure BtnAumentarFonteClick(Sender: TObject);
    procedure BtnDiminuirFonteClick(Sender: TObject);
    procedure BtnAbrirClick(Sender: TObject);
    procedure BtnRecortarClick(Sender: TObject);
    procedure BtnCopiarClick(Sender: TObject);
    procedure BtnColarClick(Sender: TObject);
    procedure BtnCorClick(Sender: TObject);
    procedure menuNovoClick(Sender: TObject);
    procedure menuAbrirClick(Sender: TObject);
    procedure menuSalvarClick(Sender: TObject);
    procedure menuImprimirClick(Sender: TObject);
    procedure menuSairClick(Sender: TObject);
    procedure menuRecortarClick(Sender: TObject);
    procedure menuCopiarClick(Sender: TObject);
    procedure menuColarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mainform: TMainform;
  FUpdating : Boolean;
  FModified : Boolean ;

implementation



{$R *.dfm}

procedure TMainform.FormCreate(Sender: TObject);
var i : Integer;
begin
 //cria o form e o texto ainda no foi modificado
 FModified := False;

 //RichEdit fica em branco e j alinhado  esquerda por "default"
 //e habilita boto de Imprimir
 BtnEsquerda.Down := True;
 BtnDireita.Down := False;
 BtnCentralizado.Down := False;
 BtnImprimir.Enabled := True;


 for i:=1 to Screen.Fonts.Count-1 do
   ComboBox1.Items.Add( Screen.Fonts[i]);

 ComboBox1.Text := 'Times New Roman';
 Spin1.Value := 12;


end;

procedure TMainform.BtnSairClick(Sender: TObject);
var Resultado : Integer;
begin
 if (FModified) and (Length(RichEdit1.Text)>0) then
  Resultado :=  Application.MessageBox('O seu texto foi modificado. Salvar alteraes no texto?',pchar(Caption),35);
  if Resultado = IDYES then
   BtnSalvarClick(self)
   else
    if Resultado = IDCANCEL then exit;

 Close;
end;

procedure TMainform.BtnNegritoClick(Sender: TObject);
begin
 if FUpdating then exit;
 if BtnNegrito.Down then
   RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style+[fsBold]
   else
     RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style-[fsBold];

end;

procedure TMainform.BtnItalicoClick(Sender: TObject);
begin
 if FUpdating then exit;
 if BtnItalico.Down then
  RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style+[fsItalic]
  else
   RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style-[fsItalic];
end;

procedure TMainform.BtnSublinhadoClick(Sender: TObject);
begin
 if FUpdating then exit;
 if BtnSublinhado.Down then
  RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style+[fsUnderline]
  else
   RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style-[fsUnderline];
end;

procedure TMainform.BtnEsquerdaClick(Sender: TObject);
begin
 if BtnEsquerda.Down then begin
  RichEdit1.Paragraph.Alignment := taLeftJustify;
  BtnDireita.Down := False;
  BtnCentralizado.Down := False;
 end;
end;

procedure TMainform.BtnCentralizadoClick(Sender: TObject);
begin
 if BtnCentralizado.Down then begin
  RichEdit1.Paragraph.Alignment := taCenter;
  BtnDireita.Down := False;
  BtnEsquerda.Down := False;
 end;

end;

procedure TMainform.BtnDireitaClick(Sender: TObject);
begin
 if BtnDireita.Down then begin
  RichEdit1.Paragraph.Alignment := taRightJustify;
  BtnCentralizado.Down := False;
  BtnEsquerda.Down := False;
 end;

end;

procedure TMainform.ComboBox1Change(Sender: TObject);
begin
 RichEdit1.SelAttributes.Name := ComboBox1.Items[ComboBox1.ItemIndex] ;
end;

procedure TMainform.Spin1Change(Sender: TObject);
begin
 RichEdit1.SelAttributes.Size := Spin1.Value ;
end;

procedure TMainform.RichEdit1SelectionChange(Sender: TObject);
begin
  FUpdating := True;
  BtnNegrito.Down := fsBold in RichEdit1.SelAttributes.Style;
  BtnItalico.Down := fsItalic in RichEdit1.SelAttributes.Style;
  BtnSublinhado.Down := fsUnderline in RichEdit1.SelAttributes.Style;
  Spin1.Text := IntToStr(RichEdit1.SelAttributes.Size);
  ComboBox1.Text := RichEdit1.SelAttributes.Name;

  if RichEdit1.Paragraph.Alignment = taLeftJustify then begin
   BtnEsquerda.Down := True;
   BtnDireita.Down := False;
   BtnCentralizado.Down := False;
  end
   else
   if RichEdit1.Paragraph.Alignment = taCenter then begin
     BtnCentralizado.Down := True;
     BtnDireita.Down := False;
     BtnEsquerda.down := False;
    end
    else
    if RichEdit1.Paragraph.Alignment = taRightJustify then begin
     BtnDireita.Down := True                         ;
     BtnEsquerda.Down := false;
     BtnCentralizado.down := False;
    end;

   if RichEdit1.Paragraph.FirstIndent > 0 then
    BtnRecuo.Down := True
    else
     BtnRecuo.Down := False;

  if RichEdit1.Paragraph.Numbering = nsBullet then
   BtnMarcador.Down := True
   else
    BtnMarcador.Down := False;
  FUpdating := False;
end;

function TMainform.CurrText: TTextAttributes;
begin
  if RichEdit1.SelLength > 0 then Result := RichEdit1.SelAttributes
  else Result := RichEdit1.DefAttributes;
end;

procedure TMainform.BtnTachadoClick(Sender: TObject);
begin
 if FUpdating then exit;
 if BtnTachado.Down then
   RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style+[fsStrikeOut]
   else
     RichEdit1.SelAttributes.Style := RichEdit1.SelAttributes.Style-[fsStrikeOut];
end;

procedure TMainform.BtnImprimirClick(Sender: TObject);
begin
 if PrintDialog1.Execute then
  RichEdit1.Print(Caption);

end;

procedure TMainform.BtnSalvarClick(Sender: TObject);
begin
 if Length(SaveDialog1.FileName)=0 then
  if SaveDialog1.Execute then
   RichEdit1.Lines.SaveToFile(SaveDialog1.FileName)
;
 FModified := False;
end;

procedure TMainform.RichEdit1Change(Sender: TObject);
begin
 FModified := RichEdit1.Modified ;
 StatusBar1.Panels[0].Text := 'Linhas: '+ InttoStr(RichEdit1.Lines.Count);

end;

procedure TMainform.BtnLimparClick(Sender: TObject);
begin
 if Length(RichEdit1.Text) > 0 then
  if application.messagebox('Apagar o contedo deste texto?',pchar(Caption),52)=IDYES then
   RichEdit1.Lines.Clear;
end;

procedure TMainform.BtnMarcadorClick(Sender: TObject);
begin
  if FUpdating then Exit;
   RichEdit1.Paragraph.Numbering := TNumberingStyle(BtnMarcador.Down);
end;

procedure TMainform.BtnRecuoClick(Sender: TObject);
begin
 if FUpdating then exit;
 if BtnRecuo.Down then
  RichEdit1.Paragraph.FirstIndent := 15
  else
   RichEdit1.Paragraph.FirstIndent := 0;
end;

procedure TMainform.BtnAumentarFonteClick(Sender: TObject);
begin
 if RichEdit1.SelAttributes.Size < 60 then
  RichEdit1.SelAttributes.Size := RichEdit1.SelAttributes.Size + 1;
 Spin1.Value := Spin1.Value + 1;
end;

procedure TMainform.BtnDiminuirFonteClick(Sender: TObject);
begin
 RichEdit1.SelAttributes.Size := RichEdit1.SelAttributes.Size - 1;
 Spin1.Value := Spin1.Value - 1;
end;

procedure TMainform.BtnAbrirClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  RichEdit1.Lines.LoadFromFile( OpenDialog1.FileName ); 
end;

procedure TMainform.BtnRecortarClick(Sender: TObject);
begin
 RichEdit1.CutToClipboard ;
end;

procedure TMainform.BtnCopiarClick(Sender: TObject);
begin
 RichEdit1.CopyToClipboard ;
end;

procedure TMainform.BtnColarClick(Sender: TObject);
begin
  RichEdit1.PasteFromClipboard ;
end;

procedure TMainform.BtnCorClick(Sender: TObject);
begin
 if ColorDialog1.Execute then
  RichEdit1.SelAttributes.Color := ColorDialog1.Color ;
end;

procedure TMainform.menuNovoClick(Sender: TObject);
begin
 BtnLimparClick(self);
end;

procedure TMainform.menuAbrirClick(Sender: TObject);
begin
 BtnAbrirClick(self);
end;

procedure TMainform.menuSalvarClick(Sender: TObject);
begin
 BtnSalvarClick(self);
end;

procedure TMainform.menuImprimirClick(Sender: TObject);
begin
 BtnImprimirClick(self);
end;

procedure TMainform.menuSairClick(Sender: TObject);
begin
 BtnSairClick(self);
end;

procedure TMainform.menuRecortarClick(Sender: TObject);
begin
 BtnRecortarClick(self);
end;

procedure TMainform.menuCopiarClick(Sender: TObject);
begin
 BtnCopiarClick(self);
end;

procedure TMainform.menuColarClick(Sender: TObject);
begin
 BtnColarClick(self);
end;

end.
